## frugen 2.0+git20240917.25293b1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# To make frugen 32-bit, set BINARY_32BIT or use an external toolchain file
option(BINARY_32BIT "compile 32bit version" OFF)
if(BINARY_32BIT)
	# Note: this have to go before PROJECT
	set(CMAKE_C_COMPILER gcc -m32)
endif(BINARY_32BIT)

execute_process(COMMAND
	git
	describe
	--always
	--long
	--dirty
	WORKING_DIRECTORY
	"${CMAKE_CURRENT_SOURCE_DIR}"
	RESULT_VARIABLE
	res
	OUTPUT_VARIABLE
	gitver
	ERROR_QUIET
	OUTPUT_STRIP_TRAILING_WHITESPACE
)
if(NOT res EQUAL 0)
	set(gitver "v2.0-dirty-orphan")
endif()

string(REPLACE "v" "" gitver "${gitver}")
string(REPLACE "-" "." gitver "${gitver}")

# This is the version of the project w/o hash information
string(REGEX REPLACE "((\\.?[0-9]+)+).*" "\\1" gitver_short "${gitver}")
project(frugen VERSION ${gitver_short} LANGUAGES C)

option(BUILD_SHARED_LIB "build shared library" ON)
option(BINARY_STATIC "link all libs static when compile frugen" OFF)
option(ENABLE_JSON "enable JSON support" ON)
option(JSON_STATIC "link json-c library statically" OFF)
option(DEBUG_OUTPUT "show extra debug output" OFF)

set(CMAKE_C_FLAGS_RELEASE "-Os -Wall -Werror -Wfatal-errors")
set(CMAKE_C_FLAGS_DEBUG "-g3 -O0 -Wall -Werror -Wfatal-errors")
if(MSVC)
	# warning level 4
	add_compile_options(/W4)
else(MSVC)
	# additional warnings
	add_compile_options(-Wall -Wextra -Wunreachable-code)
endif(MSVC)

if(DEBUG_OUTPUT)
	add_definitions(-DDEBUG)
endif(DEBUG_OUTPUT)

add_definitions(-DVERSION="${gitver}")

configure_file(fru.h.in fru.h @ONLY)

include("doxygen.cmake")
set(DOXY_PROJECT_NUMBER "${gitver}")
set(DOXY_OUTPUT_LANGUAGE "English")
set(DOXY_INPUT ${PROJECT_SOURCE_DIR})
set(DOXY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/docs")
add_documentation(docs Doxyfile)

# build libfru
set(libfru_SOURCES
	fru.c
	fru-errno.c
)
set(libfru_HEADERS
	${CMAKE_CURRENT_BINARY_DIR}/fru.h
)
if(BUILD_SHARED_LIB)
	add_library(fru-shared SHARED ${libfru_SOURCES} ${libfru_HEADERS})
	add_library(frugen::fru-shared ALIAS fru-shared)
	target_include_directories(fru-shared PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
		$<INSTALL_INTERFACE:include>
	)
	set_target_properties(fru-shared PROPERTIES OUTPUT_NAME fru CLEAN_DIRECT_OUTPUT 1)
	set_target_properties(fru-shared PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
	set_target_properties(fru-shared PROPERTIES PUBLIC_HEADER "${libfru_HEADERS}")
	list(APPEND LIB_TARGETS "fru-shared")
endif(BUILD_SHARED_LIB)
if(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
	add_library(fru-static STATIC ${libfru_SOURCES} ${libfru_HEADERS})
	add_library(frugen::fru-static ALIAS fru-static)
	target_include_directories(fru-static PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
		$<INSTALL_INTERFACE:include>
	)
	set_target_properties(fru-static PROPERTIES OUTPUT_NAME fru CLEAN_DIRECT_OUTPUT 1)
	set_target_properties(fru-static PROPERTIES PUBLIC_HEADER "${libfru_HEADERS}")
	list(APPEND LIB_TARGETS "fru-static")
endif(BINARY_STATIC OR NOT BUILD_SHARED_LIB)

# target for frugen
set(frugen_SOURCES)
list(APPEND frugen_SOURCES frugen.c)
if(ENABLE_JSON)
	list(APPEND frugen_SOURCES frugen-json.c)
endif(ENABLE_JSON)
add_executable(frugen ${frugen_SOURCES})
list(APPEND ALL_TARGETS ${LIB_TARGETS} "frugen")

if(BINARY_STATIC)
	target_link_libraries(frugen -static)
endif(BINARY_STATIC)
if(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
	target_link_libraries(frugen fru-static)
else(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
	target_link_libraries(frugen fru-shared)
endif(BINARY_STATIC OR NOT BUILD_SHARED_LIB)

if(ENABLE_JSON)
	find_package(json-c CONFIG REQUIRED)
	message (STATUS "Using JSON Library found at " ${json-c_DIR})
	add_definitions(-D__HAS_JSON__)
	if(JSON_STATIC OR BINARY_STATIC)
		target_link_libraries(frugen json-c::json-c-static)
	else(JSON_STATIC OR BINARY_STATIC)
		target_link_libraries(frugen json-c::json-c)
	endif(JSON_STATIC OR BINARY_STATIC)
else(ENABLE_JSON)
	message (WARNING "JSON library support *disabled*!")
endif(ENABLE_JSON)

# install targets
install(TARGETS frugen RUNTIME DESTINATION bin)
install(TARGETS ${LIB_TARGETS}
	EXPORT ${PROJECT_NAME}-targets
	PUBLIC_HEADER DESTINATION include
	ARCHIVE DESTINATION lib
	LIBRARY DESTINATION lib
	RUNTIME DESTINATION bin
)
install(EXPORT ${PROJECT_NAME}-targets
	NAMESPACE ${PROJECT_NAME}::
	FILE ${PROJECT_NAME}-config.cmake
	DESTINATION lib/cmake/${PROJECT_NAME}
)

=== debian/changelog ===
frugen (2.0+git20240917.25293b1-1) unstable; urgency=medium

  * New upstream version 2.0+git20240917.25293b1 (closes: #1086610)

 -- Shengqi Chen <harry-chen@outlook.com>  Sat, 02 Nov 2024 17:22:26 +0800

=== debian/control ===
Source: frugen
Section: utils
Priority: optional
Standards-Version: 4.7.0
Maintainer: Shengqi Chen <harry-chen@outlook.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 doxygen,
 graphviz,
 help2man,
 libjson-c-dev,
Homepage: https://codeberg.org/IPMITool/frugen
Vcs-Git: https://salsa.debian.org/harry/frugen.git
Vcs-Browser: https://salsa.debian.org/harry/frugen
Rules-Requires-Root: no

Package: libfru2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: frugen
Description: Universal IPMI FRU Information generator / editor library
 frugen is a universal, full-featured IPMI FRU Information generator /
 editor library and command line tool, written in full compliance with
 IPMI FRU Information Storage Definition v1.0, rev. 1.3.
 .
 This package contains libfru2 shared library.

Package: libfru-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libfru2 (= ${binary:Version})
Description: Universal IPMI FRU Information generator / editor library (development files)
 frugen is a universal, full-featured IPMI FRU Information generator /
 editor library and command line tool, written in full compliance with
 IPMI FRU Information Storage Definition v1.0, rev. 1.3.
 .
 This package contains development files for libfru.

Package: frugen
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfru2 (= ${binary:Version})
Description: Universal IPMI FRU Information generator / editor
 frugen is a universal, full-featured IPMI FRU Information generator /
 editor library and command line tool, written in full compliance with
 IPMI FRU Information Storage Definition v1.0, rev. 1.3.
 .
 This package contains the frugen utility.

## frugen 2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
-if(COMMAND cmake_policy)
-	cmake_policy(SET CMP0003 NEW)
-endif(COMMAND cmake_policy)
+cmake_minimum_required(VERSION 3.5)
 
 # To make frugen 32-bit, set BINARY_32BIT or use an external toolchain file
 option(BINARY_32BIT "compile 32bit version" OFF)
@@ -42,14 +39,14 @@
 option(JSON_STATIC "link json-c library statically" OFF)
 option(DEBUG_OUTPUT "show extra debug output" OFF)
 
-set(CMAKE_C_FLAGS_RELEASE "-Os -Wall -Werror -Wfatal-errors")
-set(CMAKE_C_FLAGS_DEBUG "-g3 -O0 -Wall -Werror -Wfatal-errors")
+set(CMAKE_C_FLAGS_RELEASE "-Os")
+set(CMAKE_C_FLAGS_DEBUG "-g3 -O0")
 if(MSVC)
 	# warning level 4
 	add_compile_options(/W4)
 else(MSVC)
 	# additional warnings
-	add_compile_options(-Wall -Wextra -Wunreachable-code)
+	add_compile_options(-Wall -Werror -Wfatal-errors -Wextra -Wunreachable-code)
 endif(MSVC)
 
 if(DEBUG_OUTPUT)
@@ -118,14 +115,17 @@
 endif(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
 
 if(ENABLE_JSON)
-	find_package(json-c CONFIG REQUIRED)
-	message (STATUS "Using JSON Library found at " ${json-c_DIR})
+	find_package(PkgConfig)
+	pkg_check_modules(json-c REQUIRED json-c)
+
 	add_definitions(-D__HAS_JSON__)
 	if(JSON_STATIC OR BINARY_STATIC)
-		target_link_libraries(frugen json-c::json-c-static)
-	else(JSON_STATIC OR BINARY_STATIC)
-		target_link_libraries(frugen json-c::json-c)
-	endif(JSON_STATIC OR BINARY_STATIC)
+		target_link_libraries(frugen ${json-c_STATIC_LIBRARIES})
+	else()
+		target_link_libraries(frugen ${json-c_LIBRARIES})
+	endif()
+
+	target_include_directories(frugen PRIVATE ${json-c_INCLUDE_DIRS})
 else(ENABLE_JSON)
 	message (WARNING "JSON library support *disabled*!")
 endif(ENABLE_JSON)

=== debian/changelog ===
frugen (2.1-3) unstable; urgency=medium

  * Do source-only upload to enable migration.
  * libfru-dev: move header files back to /usr/include (this does not
    affect Multi-Arch: same).

 -- Shengqi Chen <harry@debian.org>  Fri, 28 Feb 2025 12:08:05 +0800

frugen (2.1-2) unstable; urgency=medium

  * Move documentation from libfru-dev to new binary package libfru-doc.
  * d/control:
    + bump std-ver to 4.7.1 (no changes required).
    + mark libfru-dev as Multi-Arch: same.
    + mark libfru-doc as Multi-Arch: foreign.
  * Install headers into path with host-triple to comply with Multi-Arch
    attribute.

 -- Shengqi Chen <harry@debian.org>  Wed, 26 Feb 2025 14:00:02 +0800

frugen (2.1-1) unstable; urgency=medium

  * New upstream version 2.1
  * d/patch: refresh existing patches, remove -Werror for gcc 14
  * d/control: add pkgconf in B-D, use my d.o email address
  * Refresh symbol control file for libfru2

 -- Shengqi Chen <harry@debian.org>  Wed, 12 Feb 2025 16:47:35 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: frugen
 Section: utils
 Priority: optional
-Standards-Version: 4.7.0
-Maintainer: Shengqi Chen <harry-chen@outlook.com>
+Standards-Version: 4.7.1
+Maintainer: Shengqi Chen <harry@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
@@ -10,6 +10,7 @@
  graphviz,
  help2man,
  libjson-c-dev,
+ pkgconf,
 Homepage: https://codeberg.org/IPMITool/frugen
 Vcs-Git: https://salsa.debian.org/harry/frugen.git
 Vcs-Browser: https://salsa.debian.org/harry/frugen
@@ -31,13 +32,27 @@
 Package: libfru-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, libfru2 (= ${binary:Version})
+Recommends: libfru-doc (= ${binary:Version})
 Description: Universal IPMI FRU Information generator / editor library (development files)
  frugen is a universal, full-featured IPMI FRU Information generator /
  editor library and command line tool, written in full compliance with
  IPMI FRU Information Storage Definition v1.0, rev. 1.3.
  .
  This package contains development files for libfru.
+
+Package: libfru-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Description: Universal IPMI FRU Information generator / editor library (documentation)
+ frugen is a universal, full-featured IPMI FRU Information generator /
+ editor library and command line tool, written in full compliance with
+ IPMI FRU Information Storage Definition v1.0, rev. 1.3.
+ .
+ This package contains documentation for libfru.
 
 Package: frugen
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

TARGET_LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIB=ON -DCMAKE_INSTALL_LIBDIR=$(TARGET_LIBDIR) -DBUILD_VERSION=$(DEB_VERSION_UPSTREAM)

override_dh_auto_build:
	dh_auto_build -- all docs

execute_after_dh_auto_install:
	LD_LIBRARY_PATH=debian/tmp$(TARGET_LIBDIR) help2man --version-string=$(DEB_VERSION_UPSTREAM) --name="Universal, full-featured IPMI FRU Information generator" -N -o frugen.1 debian/tmp/usr/bin/frugen

override_dh_auto_test:
	# No test suite

=== debian/watch ===
version=4
  opts="mode=git, pgpmode=none" \
  https://codeberg.org/IPMITool/frugen.git \
  refs/tags/v([\d\.]+) debian uupdate

## frugen 3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,17 @@
 	add_compile_options(/W4)
 else(MSVC)
 	# additional warnings
-	add_compile_options(-Wall -Werror -Wfatal-errors -Wextra -Wunreachable-code)
+	add_compile_options(
+		-Wall
+		-Werror
+		-Wfatal-errors
+		-Wextra
+		-Wunreachable-code
+		-Wunused-macros
+		-Wunused-local-typedefs
+		-ffunction-sections
+		-fdata-sections
+	)
 endif(MSVC)
 
 if(DEBUG_OUTPUT)
@@ -60,18 +70,40 @@
 include("doxygen.cmake")
 set(DOXY_PROJECT_NUMBER "${gitver}")
 set(DOXY_OUTPUT_LANGUAGE "English")
-set(DOXY_INPUT ${PROJECT_SOURCE_DIR})
+set(DOXY_INPUT "${PROJECT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/build")
 set(DOXY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/docs")
 add_documentation(docs Doxyfile)
 
 # build libfru
 set(libfru_SOURCES
-	fru.c
-	fru-errno.c
+	lib/fru__decode.c
+	lib/fru_enable_area.c
+	lib/fru_errno.c
+	lib/fru_add_custom.c
+	lib/fru_add_mr.c
+	lib/fru_common.c
+	lib/fru_delete_custom.c
+	lib/fru_get_custom.c
+	lib/fru_init.c
+	lib/fru_internal.c
+	lib/fru_load.c
+	lib/fru_mr_ops.c
+	lib/fru_save.c
+	lib/fru_setfield.c
+	lib/fru_setfield_binary.c
+	lib/fru_getfield.c
 )
 set(libfru_HEADERS
 	${CMAKE_CURRENT_BINARY_DIR}/fru.h
-)
+	fru_errno.h
+	lib/fru-private.h
+)
+
+set(libfru_PUBLIC_HEADERS
+	${CMAKE_CURRENT_BINARY_DIR}/fru.h
+	fru_errno.h
+)
+
 if(BUILD_SHARED_LIB)
 	add_library(fru-shared SHARED ${libfru_SOURCES} ${libfru_HEADERS})
 	add_library(frugen::fru-shared ALIAS fru-shared)
@@ -81,7 +113,7 @@
 	)
 	set_target_properties(fru-shared PROPERTIES OUTPUT_NAME fru CLEAN_DIRECT_OUTPUT 1)
 	set_target_properties(fru-shared PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
-	set_target_properties(fru-shared PROPERTIES PUBLIC_HEADER "${libfru_HEADERS}")
+	set_target_properties(fru-shared PROPERTIES PUBLIC_HEADER "${libfru_PUBLIC_HEADERS}")
 	list(APPEND LIB_TARGETS "fru-shared")
 endif(BUILD_SHARED_LIB)
 if(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
@@ -92,18 +124,57 @@
 		$<INSTALL_INTERFACE:include>
 	)
 	set_target_properties(fru-static PROPERTIES OUTPUT_NAME fru CLEAN_DIRECT_OUTPUT 1)
-	set_target_properties(fru-static PROPERTIES PUBLIC_HEADER "${libfru_HEADERS}")
+	set_target_properties(fru-static PROPERTIES PUBLIC_HEADER "${CMAKE_CURRENT_BINARY_DIR}/fru.h")
 	list(APPEND LIB_TARGETS "fru-static")
 endif(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
 
 # target for frugen
-set(frugen_SOURCES)
-list(APPEND frugen_SOURCES frugen.c)
+set(frugen_SOURCES frugen.c)
+add_executable(frugen ${frugen_SOURCES})
+
 if(ENABLE_JSON)
-	list(APPEND frugen_SOURCES frugen-json.c)
+	find_package(PkgConfig)
+	pkg_check_modules(json-c json-c)
+
+# For debugging
+#	get_cmake_property(_variableNames VARIABLES)
+#	list (SORT _variableNames)
+#	foreach (_variableName ${_variableNames})
+#	    message(STATUS "VARIABLE ${_variableName}=${${_variableName}}")
+#	endforeach()
+
+	if(json-c_FOUND)
+		if(JSON_STATIC OR BINARY_STATIC)
+# TODO: Find a way to detect that static version is indeed present
+#       as it is missing in Fedora by default
+#			if (NOT json-c_STATIC_FOUND)
+#				message (WARNING "No STATIC json-c library available")
+#				set(ENABLE_JSON false)
+#			else ()
+				target_link_libraries(frugen ${json-c_STATIC_LIBRARIES})
+#			endif ()
+		else ()
+			target_link_libraries(frugen ${json-c_LIBRARIES})
+		endif ()
+	endif ()
+
+	if (ENABLE_JSON)
+		add_definitions(-D__HAS_JSON__)
+		list(APPEND frugen_SOURCES frugen-json.c)
+		set_target_properties(frugen PROPERTIES SOURCES "${frugen_SOURCES}")
+		target_include_directories(frugen PRIVATE ${json-c_INCLUDE_DIRS})
+	else ()
+		message (WARNING "JSON library support *disabled*!")
+	endif ()
 endif(ENABLE_JSON)
-add_executable(frugen ${frugen_SOURCES})
+
 list(APPEND ALL_TARGETS ${LIB_TARGETS} "frugen")
+
+if (CMAKE_BUILD_TYPE STREQUAL "Debug")
+	set_target_properties(frugen PROPERTIES LINK_FLAGS "-Wl,--gc-sections,--print-gc-sections")
+else()
+	set_target_properties(frugen PROPERTIES LINK_FLAGS "-Wl,--gc-sections")
+endif()
 
 if(BINARY_STATIC)
 	target_link_libraries(frugen -static)
@@ -114,22 +185,6 @@
 	target_link_libraries(frugen fru-shared)
 endif(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
 
-if(ENABLE_JSON)
-	find_package(PkgConfig)
-	pkg_check_modules(json-c REQUIRED json-c)
-
-	add_definitions(-D__HAS_JSON__)
-	if(JSON_STATIC OR BINARY_STATIC)
-		target_link_libraries(frugen ${json-c_STATIC_LIBRARIES})
-	else()
-		target_link_libraries(frugen ${json-c_LIBRARIES})
-	endif()
-
-	target_include_directories(frugen PRIVATE ${json-c_INCLUDE_DIRS})
-else(ENABLE_JSON)
-	message (WARNING "JSON library support *disabled*!")
-endif(ENABLE_JSON)
-
 # install targets
 install(TARGETS frugen RUNTIME DESTINATION bin)
 install(TARGETS ${LIB_TARGETS}

=== debian/changelog ===
frugen (3.0-1) unstable; urgency=medium

  * New upstream version 3.0.
    + Bump SONAME to libfru3.
    + d/patches: refresh existing patches.
    + Rewrite symbol definition files for libfru3.
    + d/copyright: update according to upstream source.
  * d/rules: switch cmake backend to ninja.
  * d/rules: temporarily disable some gcc warning to make it compile.
  * d/control: bump std-ver to 4.7.2 (no changes required).
  * d/tests: temporarily disable json test in smoke-test.

 -- Shengqi Chen <harry@debian.org>  Thu, 14 Aug 2025 23:54:01 +0800

## frugen 3.0%2Bgit20251027.6643c5c

=== debian/changelog ===
frugen (3.0+git20251027.6643c5c-1) unstable; urgency=medium

  * d/watch: switch to version 5.
  * New upstream version 3.0+git20251027.6643c5c (closes: #1117979).
  * d/symbols: remove useless symbols from libfru3.
  * d/patches: refresh existing patches.

 -- Shengqi Chen <harry@debian.org>  Tue, 28 Oct 2025 09:40:02 +0800

## frugen 3.0+git20251027.6643c5c

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
+
+include(GenerateExportHeader)
 
 # To make frugen 32-bit, set BINARY_32BIT or use an external toolchain file
 option(BINARY_32BIT "compile 32bit version" OFF)
@@ -23,7 +25,7 @@
 	OUTPUT_STRIP_TRAILING_WHITESPACE
 )
 if(NOT res EQUAL 0)
-	set(gitver "v2.0-dirty-orphan")
+	set(gitver "v3.0-dirty-orphan")
 endif()
 
 string(REPLACE "v" "" gitver "${gitver}")
@@ -39,12 +41,18 @@
 option(JSON_STATIC "link json-c library statically" OFF)
 option(DEBUG_OUTPUT "show extra debug output" OFF)
 
-set(CMAKE_C_FLAGS_RELEASE "-Os")
-set(CMAKE_C_FLAGS_DEBUG "-g3 -O0")
+message(STATUS "Compiler is ${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}")
 if(MSVC)
 	# warning level 4
 	add_compile_options(/W4)
 else(MSVC)
+	set(CMAKE_C_FLAGS_RELEASE "-Os")
+	set(CMAKE_C_FLAGS_DEBUG "-g3 -O0")
+	# Enable static analyzer for gcc 13+
+	# It still may produce some falso positives, but it's quite decent already.
+	if(CMAKE_C_COMPILER_ID STREQUAL "GNU" AND CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL "13.0")
+		add_compile_options(-fanalyzer)
+	endif()
 	# additional warnings
 	add_compile_options(
 		-Wall
@@ -70,8 +78,9 @@
 include("doxygen.cmake")
 set(DOXY_PROJECT_NUMBER "${gitver}")
 set(DOXY_OUTPUT_LANGUAGE "English")
-set(DOXY_INPUT "${PROJECT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/build")
-set(DOXY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/docs")
+set(DOXY_INPUT "${PROJECT_SOURCE_DIR} ${CMAKE_BINARY_DIR}")
+set(DOXY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/docs")
+set(DOXY_STRIP_FROM_PATH "${CMAKE_BINARY_DIR}")
 add_documentation(docs Doxyfile)
 
 # build libfru
@@ -106,6 +115,9 @@
 
 if(BUILD_SHARED_LIB)
 	add_library(fru-shared SHARED ${libfru_SOURCES} ${libfru_HEADERS})
+	set_target_properties(fru-shared PROPERTIES C_VISIBILITY_PRESET hidden)
+	generate_export_header(fru-shared BASE_NAME fru)
+
 	add_library(frugen::fru-shared ALIAS fru-shared)
 	target_include_directories(fru-shared PUBLIC
 		$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
@@ -114,23 +126,29 @@
 	set_target_properties(fru-shared PROPERTIES OUTPUT_NAME fru CLEAN_DIRECT_OUTPUT 1)
 	set_target_properties(fru-shared PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
 	set_target_properties(fru-shared PROPERTIES PUBLIC_HEADER "${libfru_PUBLIC_HEADERS}")
+	set_target_properties(fru-shared PROPERTIES C_STANDARD 23)
 	list(APPEND LIB_TARGETS "fru-shared")
 endif(BUILD_SHARED_LIB)
 if(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
 	add_library(fru-static STATIC ${libfru_SOURCES} ${libfru_HEADERS})
 	add_library(frugen::fru-static ALIAS fru-static)
+	set_target_properties(fru-static PROPERTIES C_VISIBILITY_PRESET hidden)
+	generate_export_header(fru-static BASE_NAME fru)
 	target_include_directories(fru-static PUBLIC
 		$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
 		$<INSTALL_INTERFACE:include>
 	)
 	set_target_properties(fru-static PROPERTIES OUTPUT_NAME fru CLEAN_DIRECT_OUTPUT 1)
 	set_target_properties(fru-static PROPERTIES PUBLIC_HEADER "${CMAKE_CURRENT_BINARY_DIR}/fru.h")
+	set_target_properties(fru-static PROPERTIES C_STANDARD 23)
 	list(APPEND LIB_TARGETS "fru-static")
 endif(BINARY_STATIC OR NOT BUILD_SHARED_LIB)
 
 # target for frugen
 set(frugen_SOURCES frugen.c)
 add_executable(frugen ${frugen_SOURCES})
+
+set_target_properties(frugen PROPERTIES C_VISIBILITY_PRESET default)
 
 if(ENABLE_JSON)
 	find_package(PkgConfig)
@@ -170,11 +188,15 @@
 
 list(APPEND ALL_TARGETS ${LIB_TARGETS} "frugen")
 
-if (CMAKE_BUILD_TYPE STREQUAL "Debug")
-	set_target_properties(frugen PROPERTIES LINK_FLAGS "-Wl,--gc-sections,--print-gc-sections")
-else()
-	set_target_properties(frugen PROPERTIES LINK_FLAGS "-Wl,--gc-sections")
+if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+	if (CMAKE_BUILD_TYPE STREQUAL "Debug")
+		set_target_properties(frugen PROPERTIES LINK_FLAGS "-Wl,--gc-sections,--print-gc-sections")
+	else()
+		set_target_properties(frugen PROPERTIES LINK_FLAGS "-Wl,--gc-sections")
+	endif()
 endif()
+
+set_target_properties(frugen PROPERTIES C_STANDARD 23)
 
 if(BINARY_STATIC)
 	target_link_libraries(frugen -static)

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: frugen
 Section: utils
 Priority: optional
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Maintainer: Shengqi Chen <harry@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
@@ -10,13 +10,14 @@
  graphviz,
  help2man,
  libjson-c-dev,
+ ninja-build,
  pkgconf,
 Homepage: https://codeberg.org/IPMITool/frugen
 Vcs-Git: https://salsa.debian.org/harry/frugen.git
 Vcs-Browser: https://salsa.debian.org/harry/frugen
 Rules-Requires-Root: no
 
-Package: libfru2
+Package: libfru3
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -27,13 +28,13 @@
  editor library and command line tool, written in full compliance with
  IPMI FRU Information Storage Definition v1.0, rev. 1.3.
  .
- This package contains libfru2 shared library.
+ This package contains libfru shared library.
 
 Package: libfru-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libfru2 (= ${binary:Version})
+Depends: ${misc:Depends}, libfru3 (= ${binary:Version})
 Recommends: libfru-doc (= ${binary:Version})
 Description: Universal IPMI FRU Information generator / editor library (development files)
  frugen is a universal, full-featured IPMI FRU Information generator /
@@ -56,7 +57,7 @@
 
 Package: frugen
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libfru2 (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libfru3 (= ${binary:Version})
 Description: Universal IPMI FRU Information generator / editor
  frugen is a universal, full-featured IPMI FRU Information generator /
  editor library and command line tool, written in full compliance with

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND = -Wno-stringop-truncation
 
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/pkg-info.mk
@@ -8,7 +9,7 @@
 TARGET_LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)
 
 %:
-	dh $@ --buildsystem=cmake
+	dh $@ --buildsystem=cmake+ninja
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DBUILD_SHARED_LIB=ON -DCMAKE_INSTALL_LIBDIR=$(TARGET_LIBDIR) -DBUILD_VERSION=$(DEB_VERSION_UPSTREAM)

=== debian/tests/control ===
Tests: smoke-test
Restrictions: allow-stderr
Depends: frugen

=== debian/watch ===
Version: 5
Source: https://codeberg.org/IPMITool/frugen.git
Mode: git
PgpMode: none
Matching-Pattern: refs/tags/v([\d\.]+)
